Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 13096)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/AlpsGeneticAlgorithm.cs	(revision 13110)
@@ -114,7 +114,4 @@
       get { return (IValueParameter<IntValue>)Parameters["MatingPoolRange"]; }
     }
-    private IValueParameter<BoolValue> ContinuousReseedingParameter {
-      get { return (IValueParameter<BoolValue>)Parameters["ContinuousReseeding"]; }
-    }
 
     private IValueParameter<MultiTerminator> TerminatorParameter {
@@ -198,8 +195,4 @@
       get { return MatingPoolRangeParameter.Value; }
       set { MatingPoolRangeParameter.Value = value; }
-    }
-    public BoolValue ContinuousReseeding {
-      get { return ContinuousReseedingParameter.Value; }
-      set { ContinuousReseedingParameter.Value = value; }
     }
 
@@ -300,5 +293,4 @@
 
       Parameters.Add(new ValueParameter<IntValue>("MatingPoolRange", "The range of layers used for creating a mating pool. (1 = current + previous layer)", new IntValue(1)) { Hidden = true });
-      Parameters.Add(new ValueParameter<BoolValue>("ContinuousReseeding", "Instead of replacing the lowest layer every AgeGap generations replace 1/AgeGap individuals every generation", new BoolValue(false)) { Hidden = true });
 
       Parameters.Add(new ValueParameter<MultiTerminator>("Terminator", "The termination criteria which sould be checked.", new MultiTerminator()));
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/EldersEmigrator.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/EldersEmigrator.cs	(revision 13096)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/EldersEmigrator.cs	(revision 13110)
@@ -61,5 +61,5 @@
       eldersSelector.Successor = null;
 
-      shiftToRightMigrator.ClockwiseMigrationDirectionParameter.Value = new BoolValue(true);
+      shiftToRightMigrator.ClockwiseMigrationParameter.Value = new BoolValue(true);
       shiftToRightMigrator.Successor = mergingProsessor;
 
Index: branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerReseeder.cs
===================================================================
--- branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerReseeder.cs	(revision 13096)
+++ branches/ALPS/HeuristicLab.Algorithms.ALPS/3.3/LayerReseeder.cs	(revision 13110)
@@ -28,5 +28,4 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Selection;
 
 namespace HeuristicLab.Algorithms.ALPS {
@@ -44,7 +43,4 @@
     }
 
-    private ILookupParameter<BoolValue> ContinuousReseedingParameter {
-      get { return (ILookupParameter<BoolValue>)Parameters["ContinuousReseeding"]; }
-    }
     private ILookupParameter<IntValue> GenerationsParameter {
       get { return (ILookupParameter<IntValue>)Parameters["Generations"]; }
@@ -74,5 +70,4 @@
     public LayerReseeder()
       : base() {
-      Parameters.Add(new LookupParameter<BoolValue>("ContinuousReseeding"));
       Parameters.Add(new LookupParameter<IntValue>("Generations"));
       Parameters.Add(new LookupParameter<IntValue>("AgeGap"));
@@ -80,52 +75,15 @@
       operatorGraph = new OperatorGraph();
 
-      var subScopesCounter = new SubScopesCounter();
-      var numberOfReplacedCalculator = new ExpressionCalculator() { Name = "NumberOfReplaced = if ContinuousReseeding then max(LayerPopulationSize - (PopulationSize - PopulationSize / AgeGap), 0) else PopulationSize" };
-      var numberOfNewIndividualsCalculator = new ExpressionCalculator() { Name = "NumberOfNewIndividuals = PopulationSize - (LayerPopulatioSize - NumberOfReplaced)" };
-      var oldestSelector = new BestSelector();
-      var processOldest = new SubScopesProcessor();
       var removeIndividuals = new SubScopesRemover();
       var createIndividuals = new SolutionsCreator();
-      var mergeIndididuals = new MergingReducer();
       var initializeAgeProsessor = new UniformSubScopesProcessor();
       var initializeAge = new VariableCreator() { Name = "Initialize Age" };
       var incrEvaluatedSolutionsAfterReseeding = new SubScopesCounter() { Name = "Update EvaluatedSolutions" };
-      var subScopesCounter2 = new SubScopesCounter();
 
-      OperatorGraph.InitialOperator = subScopesCounter;
-
-      subScopesCounter.ValueParameter.ActualName = "LayerPopulationSize";
-      subScopesCounter.AccumulateParameter.Value = new BoolValue(false);
-      subScopesCounter.Successor = numberOfReplacedCalculator;
-
-      numberOfReplacedCalculator.CollectedValues.Add(new LookupParameter<BoolValue>("ContinuousReseeding"));
-      numberOfReplacedCalculator.CollectedValues.Add(new LookupParameter<IntValue>("LayerPopulationSize"));
-      numberOfReplacedCalculator.CollectedValues.Add(new LookupParameter<IntValue>("PopulationSize"));
-      numberOfReplacedCalculator.CollectedValues.Add(new LookupParameter<IntValue>("AgeGap"));
-      numberOfReplacedCalculator.ExpressionResultParameter.ActualName = "NumberOfReplaced";
-      const string numSelected = "LayerPopulationSize PopulationSize PopulationSize AgeGap / - -";
-      numberOfReplacedCalculator.ExpressionParameter.Value = new StringValue(numSelected + " 0 0 " + numSelected + " < if PopulationSize ContinuousReseeding if toint");
-      numberOfReplacedCalculator.Successor = numberOfNewIndividualsCalculator;
-
-      numberOfNewIndividualsCalculator.CollectedValues.Add(new LookupParameter<IntValue>("PopulationSize"));
-      numberOfNewIndividualsCalculator.CollectedValues.Add(new LookupParameter<IntValue>("NumberOfReplaced"));
-      numberOfNewIndividualsCalculator.CollectedValues.Add(new LookupParameter<IntValue>("LayerPopulationSize"));
-      numberOfNewIndividualsCalculator.ExpressionResultParameter.ActualName = "NumberOfNewIndividuals";
-      numberOfNewIndividualsCalculator.ExpressionParameter.Value = new StringValue("PopulationSize LayerPopulationSize NumberOfReplaced - - toint");
-      numberOfNewIndividualsCalculator.Successor = oldestSelector;
-
-      oldestSelector.QualityParameter.ActualName = "Age";
-      oldestSelector.NumberOfSelectedSubScopesParameter.ActualName = "NumberOfReplaced";
-      oldestSelector.MaximizationParameter.Value = new BoolValue(true);
-      oldestSelector.CopySelected = new BoolValue(false);
-      oldestSelector.Successor = processOldest;
-
-      processOldest.Operators.Add(new EmptyOperator());
-      processOldest.Operators.Add(removeIndividuals);
-      processOldest.Successor = mergeIndididuals;
+      OperatorGraph.InitialOperator = removeIndividuals;
 
       removeIndividuals.Successor = createIndividuals;
 
-      createIndividuals.NumberOfSolutionsParameter.ActualName = "NumberOfNewIndividuals";
+      createIndividuals.NumberOfSolutionsParameter.ActualName = "PopulationSize";
       createIndividuals.Successor = initializeAgeProsessor;
 
@@ -139,18 +97,12 @@
       incrEvaluatedSolutionsAfterReseeding.AccumulateParameter.Value = new BoolValue(true);
       incrEvaluatedSolutionsAfterReseeding.Successor = null;
-
-      mergeIndididuals.Successor = subScopesCounter2;
-
-      subScopesCounter2.ValueParameter.ActualName = "LayerPopulationSize";
-      subScopesCounter2.AccumulateParameter.Value = new BoolValue(false);
     }
 
     public override IOperation Apply() {
-      bool continuousReseeding = ContinuousReseedingParameter.ActualValue.Value;
       int generations = GenerationsParameter.ActualValue.Value;
       int ageGap = AgeGapParameter.ActualValue.Value;
 
       var next = new OperationCollection(base.Apply());
-      if (continuousReseeding || generations % ageGap == 0) {
+      if (generations % ageGap == 0) {
         var layerZeroScope = ExecutionContext.Scope.SubScopes[0];
         if (operatorGraph.InitialOperator != null)