Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs	(revision 13111)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs	(revision 13112)
@@ -30,4 +30,5 @@
     private PointD originalUpperRight;
     protected List<Offset> zoomHistory;
+    protected List<RenderStage> renderStages;
 
     private bool enabled;
@@ -88,4 +89,10 @@
       Scale = 1.0;
       Group = new Group(this);
+      renderStages = new List<RenderStage> {
+        new BackgroundColorRenderStage(this),
+        new GridRenderStage(this),
+        new GroupRenderStage(this),
+        new EnabledRenderStage(this)
+      };
       Group.RedrawRequired += GroupOnRedrawRequired;
       MinimumZoomDistance = 0.01;
@@ -239,14 +246,6 @@
     public virtual void Render(Graphics graphics, int width, int height) {
       mySizeInPixels = new Size(width, height);
-      graphics.Clear(backgroundColor);
-      Group.PreDraw(graphics);
-      Group.Draw(graphics);
-      Group.PostDraw(graphics);
-      if (!enabled) {
-        var disabledColor = Color.FromArgb(150, SystemColors.Control);
-        var brush = new SolidBrush(disabledColor);
-        var rectangle = new System.Drawing.Rectangle(new Point(0, 0), mySizeInPixels);
-        graphics.FillRectangle(brush, rectangle);
-      }
+      foreach (var renderStage in renderStages)
+        renderStage.Render(graphics);
     }
 
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 13111)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 13112)
@@ -139,4 +139,9 @@
     </Compile>
     <Compile Include="ChartModes\SelectChartMode.cs" />
+    <Compile Include="RenderStage.cs" />
+    <Compile Include="RenderStages\BackgroundColorRenderStage.cs" />
+    <Compile Include="RenderStages\EnabledRenderStage.cs" />
+    <Compile Include="RenderStages\GridRenderStage.cs" />
+    <Compile Include="RenderStages\GroupRenderStage.cs" />
     <Compile Include="Trees\LayoutEngines\BoxesLayoutEngine.cs" />
     <Compile Include="Trees\LayoutEngines\ILayoutEngine.cs" />
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStage.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStage.cs	(revision 13112)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStage.cs	(revision 13112)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public abstract class RenderStage {
+    protected readonly IChart chart;
+
+    protected RenderStage(IChart chart) { this.chart = chart; }
+
+    public virtual void Render(Graphics graphics) { }
+  }
+}
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/BackgroundColorRenderStage.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/BackgroundColorRenderStage.cs	(revision 13112)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/BackgroundColorRenderStage.cs	(revision 13112)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public class BackgroundColorRenderStage : RenderStage {
+    public BackgroundColorRenderStage(IChart chart) : base(chart) { }
+
+    public override void Render(Graphics graphics) {
+      graphics.Clear(chart.BackgroundColor);
+    }
+  }
+}
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/EnabledRenderStage.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/EnabledRenderStage.cs	(revision 13112)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/EnabledRenderStage.cs	(revision 13112)
@@ -0,0 +1,36 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public class EnabledRenderStage : RenderStage {
+    public EnabledRenderStage(IChart chart) : base(chart) { }
+
+    public override void Render(Graphics graphics) {
+      if (chart.Enabled) return;
+
+      var disabledColor = Color.FromArgb(150, SystemColors.Control);
+      using (var brush = new SolidBrush(disabledColor))
+        graphics.FillRectangle(brush, 0, 0, chart.SizeInPixels.Width, chart.SizeInPixels.Height);
+    }
+  }
+}
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GridRenderStage.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GridRenderStage.cs	(revision 13112)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GridRenderStage.cs	(revision 13112)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public class GridRenderStage : RenderStage {
+    public GridRenderStage(IChart chart) : base(chart) { }
+
+    public override void Render(Graphics graphics) {
+      var grid = new Grid(chart, chart.LowerLeft, chart.Size);
+      grid.PreDraw(graphics);
+      grid.Draw(graphics);
+      grid.PostDraw(graphics);
+    }
+  }
+}
Index: /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GroupRenderStage.cs
===================================================================
--- /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GroupRenderStage.cs	(revision 13112)
+++ /branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/RenderStages/GroupRenderStage.cs	(revision 13112)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Drawing;
+
+namespace HeuristicLab.Visualization {
+  public class GroupRenderStage : RenderStage {
+    public GroupRenderStage(IChart chart) : base(chart) { }
+
+    public override void Render(Graphics graphics) {
+      chart.Group.PreDraw(graphics);
+      chart.Group.Draw(graphics);
+      chart.Group.PostDraw(graphics);
+    }
+  }
+}